# coding: utf-8

"""
    Bleumi Pay REST API

    A simple and powerful REST API to integrate ERC-20, Ethereum, xDai, Algorand payments and/or payouts into your business or application  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: info@bleumi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from bleumi_pay.models.payment_operation import PaymentOperation  # noqa: F401,E501


class PaginatedPaymentOperations(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'results': 'list[PaymentOperation]',
        'next_token': 'str'
    }

    attribute_map = {
        'results': 'results',
        'next_token': 'nextToken'
    }

    def __init__(self, results=None, next_token=None):  # noqa: E501
        """PaginatedPaymentOperations - a model defined in Swagger"""  # noqa: E501
        self._results = None
        self._next_token = None
        self.discriminator = None
        self.results = results
        if next_token is not None:
            self.next_token = next_token

    @property
    def results(self):
        """Gets the results of this PaginatedPaymentOperations.  # noqa: E501

        List of operations of the payment in the current page  # noqa: E501

        :return: The results of this PaginatedPaymentOperations.  # noqa: E501
        :rtype: list[PaymentOperation]
        """
        return self._results

    @results.setter
    def results(self, results):
        """Sets the results of this PaginatedPaymentOperations.

        List of operations of the payment in the current page  # noqa: E501

        :param results: The results of this PaginatedPaymentOperations.  # noqa: E501
        :type: list[PaymentOperation]
        """
        if results is None:
            raise ValueError("Invalid value for `results`, must not be `None`")  # noqa: E501

        self._results = results

    @property
    def next_token(self):
        """Gets the next_token of this PaginatedPaymentOperations.  # noqa: E501

        Cursor to fetch next page of results, empty if no more results  # noqa: E501

        :return: The next_token of this PaginatedPaymentOperations.  # noqa: E501
        :rtype: str
        """
        return self._next_token

    @next_token.setter
    def next_token(self, next_token):
        """Sets the next_token of this PaginatedPaymentOperations.

        Cursor to fetch next page of results, empty if no more results  # noqa: E501

        :param next_token: The next_token of this PaginatedPaymentOperations.  # noqa: E501
        :type: str
        """

        self._next_token = next_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaginatedPaymentOperations, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaginatedPaymentOperations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
